<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Developer Docs &mdash; 4PointX Documentation 1.0 documentation</title>
      <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
      <link rel="stylesheet" href="../_static/css/custom.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
        <script src="../_static/doctools.js"></script>
        <script src="../_static/sphinx_highlight.js"></script>
    <script src="../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../index.html" class="icon icon-home">
            4PointX Documentation
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../4pointx_docs/introduction/index.html">Introduction</a><ul class="simple">
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../4pointx_docs/getting_started_with_4pointx_cloud/index.html">Getting Started with 4PointX Cloud</a><ul class="simple">
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../4pointx_docs/deploy_4pointx_self_managed/index.html">Deploy 4PointX Self-Managed</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/deploy_4pointx_self_managed/pre_requisites/index.html">Pre-requisites</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/deploy_4pointx_self_managed/pre_installation_guide/index.html">Pre Installation Guide</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/deploy_4pointx_self_managed/pre_installation_guide/k8s_installation_guide/index.html">K8S Installation Guide</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/deploy_4pointx_self_managed/pre_installation_guide/helm_installation_guide/index.html">Helm Installation Guide</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/deploy_4pointx_self_managed/deploy_4pointx_iaot_suite/index.html">Deploy 4PointX IAoT Suite</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/deploy_4pointx_self_managed/log_in_to_4pointx_iaot_suite/index.html">Log in to 4PointX IAoT Suite</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/deploy_4pointx_self_managed/upgrade_or_uninstall_4pointx/index.html">Upgrade or Uninstall 4PointX</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/deploy_4pointx_self_managed/upgrade_or_uninstall_4pointx/upgrade_4pointx_platform/index.html">Upgrade 4PointX Platform</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/deploy_4pointx_self_managed/upgrade_or_uninstall_4pointx/uninstall_4pointx_platform/index.html">Uninstall 4PointX Platform</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/deploy_4pointx_self_managed/maintain_4px_cluster/index.html">Maintain 4PX Cluster</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/deploy_4pointx_self_managed/maintain_4px_cluster/k8s_dashboard_guide/index.html">K8S DASHBOARD Guide</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/deploy_4pointx_self_managed/maintain_4px_cluster/resize_4px_modules/index.html">Resize 4PX Modules</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/deploy_4pointx_self_managed/tls_security/index.html">TLS Security</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/deploy_4pointx_self_managed/tls_security/index.html#design">Design</a></li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/deploy_4pointx_self_managed/tls_security/index.html#updating-ssl-certificates">Updating SSL Certificates</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/deploy_4pointx_self_managed/next_steps/index.html">Next Steps</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../4pointx_docs/apps/index.html">Apps</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/apps/energy_monitoring_system_ems/index.html">Energy Monitoring System (EMS)</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/apps/energy_monitoring_system_ems/specific_energy/index.html">Specific Energy</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/apps/energy_monitoring_system_ems/idle_energy/index.html">Idle Energy</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/apps/energy_monitoring_system_ems/product_variation/index.html">Product Variation</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/apps/energy_monitoring_system_ems/other_info_ems/index.html">Other Info - EMS</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/apps/energy_monitoring_system_ems/other_info_ems/articles_references_ems/index.html">Articles &amp; References - EMS</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/energy_monitoring_system_ems/other_info_ems/articles_references_ems/index.html#power-meters">Power Meters</a></li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/energy_monitoring_system_ems/other_info_ems/articles_references_ems/index.html#oem-vendors">OEM Vendors</a></li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/energy_monitoring_system_ems/other_info_ems/articles_references_ems/index.html#articles">Articles</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../4pointx_docs/apps/energy_monitoring_system_ems/other_info_ems/articles_references_ems/index.html#things-you-should-consider-when-choosing-a-power-meter">3 Things You Should Consider When Choosing a Power Meter</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/index.html">Condition-based Maintenance (CBM)</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/summary/index.html">Summary</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/asset_health_dashboard/index.html">Asset Health Dashboard</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/real_time_monitoring/index.html">Real-time Monitoring</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/real_time_monitoring/index.html#grouping-interval-logic-implemented-in-the-front-end">Grouping Interval logic implemented in the Front-End:</a></li>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/real_time_monitoring/index.html#code">Code:</a></li>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/real_time_monitoring/index.html#id1">Code:</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/process_correlation/index.html">Process Correlation</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/fault_diagnostics/index.html">Fault Diagnostics</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/index.html">Other Info - CM</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html">Competitor Solutions - CM</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#teco-group">Teco Group</a></li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#infinite-uptime">Infinite Uptime</a></li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#web-app">Web App</a></li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#sensor-manual">Sensor Manual</a></li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#api-documentation">API Documentation</a></li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#rs-485-modbus-specs">RS-485/ Modbus Specs</a></li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#dashboard">Dashboard</a></li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#gd-folder">GD Folder</a></li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#datakrew">DataKrew</a></li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#sample-cases">Sample Cases</a></li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#case-1">Case 1</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#diagnostics">Diagnostics</a></li>
<li class="toctree-l6"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#detailed-report-attached">Detailed report attached</a></li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#case-2">Case 2</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#id1">Diagnostics</a></li>
<li class="toctree-l6"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#id2">Detailed report attached</a></li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#bk-vibro">BK Vibro</a></li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#gantner-instruments">Gantner Instruments</a></li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#vibro-meter">Vibro-meter</a></li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#omnidots">Omnidots</a></li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#rokade-rototechniks">Rokade Rototechniks</a></li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#cmtechnologies">cmtechnologies</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/articles_and_blogs_cm/index.html">Articles and Blogs - CM</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/articles_and_blogs_cm/index.html#treatment-for-machine-vibration-problems">Treatment for Machine Vibration Problems</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/apps/predictive_maintenance_pdm/index.html">Predictive Maintenance (PdM)</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/apps/predictive_maintenance_pdm/asset_anomalies/index.html">Asset Anomalies</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/apps/predictive_maintenance_pdm/process_anomalies/index.html">Process Anomalies</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/apps/predictive_maintenance_pdm/other_info_pdm/index.html">Other Info - PdM</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/apps/predictive_maintenance_pdm/other_info_pdm/competitor_solutions_anomaly/index.html">Competitor Solutions - Anomaly</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/apps/predictive_maintenance_pdm/other_info_pdm/competitor_solutions_anomaly/index.html#sparkcognition">SparkCognition</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/apps/predictive_maintenance_pdm/other_info_pdm/digital_twin_articles/index.html">Digital Twin articles</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../4pointx_docs/dashboards/index.html">Dashboards</a><ul class="simple">
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../4pointx_docs/alerting/index.html">Alerting</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/alerting/alerts/index.html">Alerts</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/alerting/watchers/index.html">Watchers</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../4pointx_docs/notebooks/index.html">Notebooks</a><ul class="simple">
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../4pointx_docs/data_management/index.html">Data Management</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/index.html">IoT Gateways</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html">IoT Gateways Introduction</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#introduction">Introduction</a></li>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#data-onboarding">Data Onboarding</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#edge-iot-gateway">Edge IoT Gateway</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#modbus-rtu">Modbus RTU</a></li>
<li class="toctree-l6"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#opc-ua">OPC-UA</a><ul>
<li class="toctree-l7"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#opc-server-python-producer-kafka-python-consumer-elasticsearch">OPC Server &gt; Python (Producer) &gt; Kafka &gt; Python (Consumer) &gt; Elasticsearch</a></li>
</ul>
</li>
<li class="toctree-l6"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#modbus-tcp">Modbus TCP</a></li>
<li class="toctree-l6"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#file">File</a><ul>
<li class="toctree-l7"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#steps-to-onboard-data-from-file">Steps to onboard data from File</a></li>
<li class="toctree-l7"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#installing-logstash">Installing Logstash</a><ul>
<li class="toctree-l8"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#centos">CentOS</a></li>
</ul>
</li>
<li class="toctree-l7"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#testing-transformed-data">Testing Transformed Data</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#third-party-apps">Third-Party Apps</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#infinite-uptime">Infinite Uptime</a></li>
<li class="toctree-l6"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#cimcon-digital">CimCon Digital</a></li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#cloud">Cloud</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#aws-s3">AWS S3</a></li>
<li class="toctree-l6"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#google-cloud-storage">Google Cloud Storage</a></li>
<li class="toctree-l6"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#azure-data-lake">Azure Data Lake</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/edge_iot_gateways/index.html">Edge IoT Gateways</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/edge_iot_gateways/index.html#initial-configuration-steps">Initial Configuration Steps</a></li>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/data_management/iot_gateways/edge_iot_gateways/index.html#testing-modbus-slaves">Testing Modbus Slaves</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/data_management/asset_metadata/index.html">Asset Metadata</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/data_management/asset_metadata/plants/index.html">Plants</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/data_management/asset_metadata/functions/index.html">Functions</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/data_management/asset_metadata/functions/function_monitors/index.html">Function Monitors</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/data_management/asset_metadata/assets/index.html">Assets</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/data_management/asset_metadata/assets/asset_monitors/index.html">Asset Monitors</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../4pointx_docs/administration/index.html">Administration</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/administration/user_management/index.html">User Management</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/administration/user_management/security_rbac/index.html">Security - RBAC</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/administration/user_management/security_rbac/index.html#roles">Roles</a></li>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/administration/user_management/security_rbac/index.html#plant-viewer">Plant Viewer</a></li>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/administration/user_management/security_rbac/index.html#plant-analyst">Plant Analyst</a></li>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/administration/user_management/security_rbac/index.html#plant-admin">Plant Admin</a></li>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/administration/user_management/security_rbac/index.html#site-admin">Site Admin</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/administration/user_management/support_users/index.html">Support Users</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/administration/user_management/support_users/index.html#steps-to-create-support-users-ui">Steps to create support users (UI)</a></li>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/administration/user_management/support_users/index.html#create-support-users-using-dev-tools">Create support users using Dev Tools</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/administration/user_management/support_users/index.html#repeat-step-no-5-for-support-admin-user">Repeat Step No. 5 for support-admin user.</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/administration/license_management/index.html">License Management</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../4pointx_docs/partners/index.html">Partners</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/partners/oem_partners/index.html">OEM Partners</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/partners/oem_partners/index.html#hardware-partners">Hardware Partners</a></li>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/partners/oem_partners/index.html#other-info">Other Info</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/partners/oem_partners/index.html#tecom">Tecom</a></li>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/partners/oem_partners/index.html#durham-instruments">Durham Instruments</a></li>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/partners/oem_partners/index.html#https-disensors-com-products-accelerometers-mems">https://disensors.com/products/accelerometers/mems/</a></li>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/partners/oem_partners/index.html#converters">Converters</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../4pointx_docs/test_page_for_sphinix_converter/index.html">Test page for sphinix converter</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../4pointx_docs/test_page_for_sphinix_converter/index.html#header-2">Header 2</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../4pointx_docs/test_page_for_sphinix_converter/index.html#header-3">Header 3</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../4pointx_docs/test_page_for_sphinix_converter/index.html#header-4">Header 4</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../4pointx_docs/test_page_for_sphinix_converter/index.html#header-5">Header 5</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../4pointx_docs/test_page_for_sphinix_converter/index.html#header-6">Header 6</a><ul>
<li class="toctree-l7"><a class="reference internal" href="../4pointx_docs/test_page_for_sphinix_converter/how_to/index.html">How to</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<p class="caption" role="heading"><span class="caption-text">API Documentation</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../API/Asset_Metadata/index.html"><strong>Asset Metadata APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../API/Asset_Metadata/assets.html"><strong>Assets</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/assets.html#create-asset"><strong>Create Asset</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/assets.html#delete-asset"><strong>Delete Asset</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/assets.html#update-asset"><strong>Update Asset</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/assets.html#fetch-asset"><strong>Fetch Asset</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/assets.html#fetch-list-of-assets"><strong>Fetch List of Assets</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/assets.html#get-count-of-assets"><strong>Get Count of Assets</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/Asset_Metadata/functions.html"><strong>Functions</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/functions.html#create-a-function"><strong>Create a Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/functions.html#delete-a-function"><strong>Delete a Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/functions.html#update-function"><strong>Update Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/functions.html#fetch-function"><strong>Fetch Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/functions.html#fetch-list-of-functions"><strong>Fetch List of Functions</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/Asset_Metadata/monitors.html"><strong>Monitors</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/monitors.html#create-a-monitor"><strong>Create a Monitor</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/monitors.html#delete-monitor"><strong>Delete Monitor</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/monitors.html#update-monitor"><strong>Update Monitor</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/monitors.html#fetch-monitors"><strong>Fetch Monitors</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/monitors.html#fetch-list-of-monitors"><strong>Fetch List of Monitors</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/monitors.html#get-count-of-monitors"><strong>Get Count of Monitors</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/Asset_Metadata/plants.html"><strong>Plants</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/plants.html#create-a-plant"><strong>Create a Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/plants.html#delete-a-plant"><strong>Delete a Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/plants.html#update-plant"><strong>Update Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/plants.html#fetch-plant"><strong>Fetch Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/plants.html#fetch-list-of-plants"><strong>Fetch List of Plants</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/Asset_Metadata/pipelines.html"><strong>Pipelines</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/pipelines.html#fetch-list-of-pipelines"><strong>Fetch List of Pipelines</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/pipelines.html#count-pipelines"><strong>Count Pipelines</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/pipelines.html#execute-pipeline-action"><strong>Execute Pipeline Action</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/Asset_Metadata/pipelines_edge.html"><strong>Pipelines (Edge Server)</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/pipelines_edge.html#create-edge-server-pipeline"><strong>Create Edge Server Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/pipelines_edge.html#delete-pipeline"><strong>Delete Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/pipelines_edge.html#update-pipeline"><strong>Update Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/pipelines_edge.html#fetch-pipeline"><strong>Fetch Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/pipelines_edge.html#handshake"><strong>Handshake</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/pipelines_edge.html#firmware"><strong>Firmware</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/Asset_Metadata/pipelines_IU.html"><strong>Pipelines (Infinite Uptime)</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/pipelines_IU.html#create-iu-pipeline"><strong>Create IU Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/pipelines_IU.html#delete-pipeline"><strong>Delete Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/pipelines_IU.html#update-pipeline"><strong>Update Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/pipelines_IU.html#fetch-pipeline"><strong>Fetch Pipeline</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/Asset_Metadata/sites.html"><strong>Sites</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/sites.html#create-a-new-site"><strong>Create a New Site</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/sites.html#delete-site"><strong>Delete Site</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/sites.html#update-site"><strong>Update Site</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/sites.html#fetch-site"><strong>Fetch Site</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/sites.html#fetch-list-of-sites"><strong>Fetch List of Sites</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/Asset_Metadata/samples.html"><strong>Samples</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/samples.html#retrieve-sample-trend"><strong>Retrieve Sample Trend</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/samples.html#retrieve-sample-count"><strong>Retrieve Sample Count</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/Asset_Metadata/tags.html"><strong>Tags</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/tags.html#retrieve-tags-list"><strong>Retrieve Tags List</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/tags.html#retrieve-tags-count"><strong>Retrieve Tags Count</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/tags.html#query-tags-trend"><strong>Query Tags Trend</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/Asset_Metadata/others.html"><strong>Other APIs</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Asset_Metadata/others.html#server-time"><strong>Server Time</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../API/EMS/index.html"><strong>EMS APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../API/EMS/ems_asset.html">EMS Asset</a></li>
<li class="toctree-l2"><a class="reference internal" href="../API/EMS/ems_benchmarking.html"><strong>EMS Benchmarking</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/EMS/ems_benchmarking.html#fetch-product-variation-table-for-plant"><strong>Fetch Product Variation Table for Plant</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/EMS/ems_function.html"><strong>EMS Function</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/EMS/ems_function.html#fetch-energy-metrics-for-function"><strong>Fetch Energy Metrics for Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/EMS/ems_function.html#fetch-energy-metrics-for-functions-in-plant"><strong>Fetch Energy Metrics for Functions in Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/EMS/ems_function.html#fetch-energy-metric-trend-for-function"><strong>Fetch Energy Metric Trend for Function</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/EMS/ems_monitor.html"><strong>EMS Monitor</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/EMS/ems_monitor.html#fetch-energy-metrics-for-monitor"><strong>Fetch Energy Metrics for Monitor</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/EMS/ems_monitor.html#fetch-energy-metrics-monitors-in-plant-or-function"><strong>Fetch Energy Metrics Monitors in Plant or Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/EMS/ems_monitor.html#fetch-energy-metric-trend-for-monitor"><strong>Fetch Energy Metric trend for Monitor</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/EMS/ems_plant.html"><strong>EMS Plant</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/EMS/ems_plant.html#fetch-energy-metrics-for-plant"><strong>Fetch Energy Metrics for Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/EMS/ems_plant.html#fetch-energy-metric-trend-for-plant"><strong>Fetch Energy Metric trend for Plant</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../API/Notebooks/index.html"><strong>Notebooks APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../API/Notebooks/notebooks.html"><strong>Notebooks</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Notebooks/notebooks.html#create-notebook"><strong>Create Notebook</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Notebooks/notebooks.html#delete-notebook"><strong>Delete Notebook</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Notebooks/notebooks.html#rename-notebook"><strong>Rename Notebook</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Notebooks/notebooks.html#fetch-notebook-details"><strong>Fetch Notebook Details</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Notebooks/notebooks.html#fetch-list-of-notebooks"><strong>Fetch List of Notebooks</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Notebooks/notebooks.html#fetch-count-of-notebooks"><strong>Fetch Count of Notebooks</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Notebooks/notebooks.html#run-notebook"><strong>Run Notebook</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Notebooks/notebooks.html#schedule-notebook"><strong>Schedule Notebook</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Notebooks/notebooks.html#unschedule-notebook"><strong>Unschedule Notebook</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../API/Alerting/index.html"><strong>Alerting APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../API/Alerting/alerts.html"><strong>Alerts</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Alerting/alerts.html#fetch-alerts-count"><strong>Fetch Alerts Count</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Alerting/alerts.html#fetch-list-of-alerts"><strong>Fetch List of Alerts</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Alerting/alerts.html#fetch-alerts-trend"><strong>Fetch Alerts Trend</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/Alerting/watchers.html"><strong>Watchers</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Alerting/watchers.html#create-watcher"><strong>Create Watcher</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Alerting/watchers.html#delete-watcher"><strong>Delete Watcher</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Alerting/watchers.html#update-watcher"><strong>Update Watcher</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Alerting/watchers.html#fetch-watcher"><strong>Fetch Watcher</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Alerting/watchers.html#fetch-list-of-watchers"><strong>Fetch List of Watchers</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Alerting/watchers.html#fetch-watcher-count"><strong>Fetch Watcher Count</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../API/User_Management/index.html"><strong>User Management APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../API/User_Management/user_management.html"><strong>Users</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/User_Management/user_management.html#create-new-user"><strong>Create New User</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/User_Management/user_management.html#delete-user"><strong>Delete User</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/User_Management/user_management.html#updating-user"><strong>Updating User</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/User_Management/user_management.html#fetch-user"><strong>Fetch User</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/User_Management/user_management.html#fetch-list-of-users"><strong>Fetch List of Users</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/User_Management/password.html"><strong>Password</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/User_Management/password.html#generate-otp"><strong>Generate OTP</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/User_Management/password.html#validate-otp"><strong>Validate OTP</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/User_Management/password.html#update-user-password"><strong>Update User Password</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../API/Condition_Monitoring/index.html"><strong>CBM APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../API/Condition_Monitoring/cm_assets.html"><strong>CM Assets</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Condition_Monitoring/cm_assets.html#cm-assets-list"><strong>CM Assets List</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/Condition_Monitoring/cm_events.html"><strong>CM Events</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Condition_Monitoring/cm_events.html#update-event"><strong>Update Event</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Condition_Monitoring/cm_events.html#fetch-event"><strong>Fetch Event</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Condition_Monitoring/cm_events.html#fetch-event-list"><strong>Fetch Event List</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/Condition_Monitoring/cm_faults.html"><strong>CM Faults</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Condition_Monitoring/cm_faults.html#cm-fault-s-status"><strong>CM Fault’s Status</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/Condition_Monitoring/cm_monitors.html"><strong>CM Monitors</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Condition_Monitoring/cm_monitors.html#cm-monitor"><strong>CM Monitor</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Condition_Monitoring/cm_monitors.html#cm-monitors-list"><strong>CM Monitors List</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../API/Condition_Monitoring/cm_fft.html"><strong>CM FFT</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/Condition_Monitoring/cm_fft.html#cm-fft-peaks"><strong>CM FFT Peaks</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Condition_Monitoring/cm_fft.html#cm-asset-fault-summary"><strong>CM Asset Fault Summary</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Condition_Monitoring/cm_fft.html#cm-fft-spectrum"><strong>CM FFT Spectrum</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/Condition_Monitoring/cm_fft.html#cm-fft-spectrum-timestamps"><strong>CM FFT Spectrum Timestamps</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../API/License_Management/index.html"><strong>License Management APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../API/License_Management/license_management.html"><strong>Licenses</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../API/License_Management/license_management.html#generate-a-license"><strong>Generate a License</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/License_Management/license_management.html#update-license"><strong>Update License</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/License_Management/license_management.html#get-license"><strong>Get License</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/License_Management/license_management.html#fetch-list-of-licenses"><strong>Fetch List of Licenses</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/License_Management/license_management.html#activate-licenses"><strong>Activate Licenses</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/License_Management/license_management.html#get-notification"><strong>Get Notification</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../API/License_Management/license_management.html#verify-app-access"><strong>Verify App Access</strong></a></li>
</ul>
</li>
</ul>
</li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">4PointX Documentation</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../index.html" class="icon icon-home" aria-label="Home"></a></li>
      <li class="breadcrumb-item active">Developer Docs</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../_sources/developer_docs/index.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="developer-docs">
<h1>Developer Docs<a class="headerlink" href="#developer-docs" title="Permalink to this heading">¶</a></h1>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="devops/index.html">DevOps</a><ul>
<li class="toctree-l2"><a class="reference internal" href="devops/containers_orchestration/index.html">Containers &amp; Orchestration</a><ul>
<li class="toctree-l3"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html">Dockers</a><ul>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#introduction">Introduction</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#background">Background</a><ul>
<li class="toctree-l5"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#phase-1-single-node-deployment-completed">Phase-1 Single node deployment (Completed)</a></li>
<li class="toctree-l5"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#phase-2-mutli-node-setup-swarm-managed-cluster">Phase-2 Mutli-node setup (Swarm-managed cluster)</a></li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#list-of-docker-images">List of Docker images</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#pointx-docker-architecture-diagram">4PointX docker architecture diagram</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#cicd-repo">CICD Repo</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#reference-links">Reference links</a><ul>
<li class="toctree-l5"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#pointx-docker-architecture-cicd-flow-diagram">4PointX Docker architecture &amp; CICD flow diagram</a></li>
<li class="toctree-l5"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#pointx-docker-knowledge-session-1-recording">4PointX Docker Knowledge Session 1 recording</a></li>
<li class="toctree-l5"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#learn-dockers">Learn Dockers</a></li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#common-docker-commands">Common Docker Commands</a><ul>
<li class="toctree-l5"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#containers">Containers</a><ul>
<li class="toctree-l6"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#ways-to-debug-an-exploding-docker-container">5 ways to debug an exploding Docker container</a></li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#images">Images</a></li>
<li class="toctree-l5"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#network">Network</a></li>
<li class="toctree-l5"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#volumes">Volumes</a></li>
<li class="toctree-l5"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#registry">Registry</a><ul>
<li class="toctree-l6"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#registry-cleanup">Registry Cleanup</a></li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="devops/containers_orchestration/dockers/index.html#space-recovery">Space Recovery</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="devops/containers_orchestration/cicd/index.html">CI/CD</a><ul>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/cicd/index.html#purpose">Purpose</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/cicd/index.html#what-is-a-ci-cd-pipeline">What is a CI/CD Pipeline?</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/cicd/index.html#ci-cd-architecture-diagram">CI/CD Architecture Diagram</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/cicd/index.html#stages-in-the-ci-cd-pipeline">Stages in the CI/CD pipeline</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/cicd/index.html#source-stage-git">Source Stage (Git)</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/cicd/index.html#build-stage-api-code">Build Stage (API code)</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/cicd/index.html#deploy-stage-puller-code">Deploy Stage (Puller code)</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/cicd/index.html#guidelines-to-deploy-the-ci-cd-pipeline">Guidelines to deploy the CI/CD pipeline:</a><ul>
<li class="toctree-l5"><a class="reference internal" href="devops/containers_orchestration/cicd/index.html#while-configuring-gitlab-ci-yml">1. While configuring GitLab CI YML</a></li>
<li class="toctree-l5"><a class="reference internal" href="devops/containers_orchestration/cicd/index.html#repository-guidelines">2. Repository guidelines</a></li>
<li class="toctree-l5"><a class="reference internal" href="devops/containers_orchestration/cicd/index.html#update-the-configuration-file-as-per-the-deployment-needs">3. Update the configuration file as per the deployment needs</a></li>
<li class="toctree-l5"><a class="reference internal" href="devops/containers_orchestration/cicd/index.html#in-case-of-a-failure-clean-up-the-following-and-restart">4. In case of a failure, clean up the following and restart</a></li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/cicd/index.html#references">References</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="devops/containers_orchestration/swarm/index.html">Swarm</a><ul>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/swarm/index.html#introduction">Introduction</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/swarm/index.html#purpose">Purpose</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/swarm/index.html#roadmap">Roadmap</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/swarm/index.html#single-replica-services">Single Replica Services</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/swarm/index.html#multiple-replica-services">Multiple Replica Services</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/swarm/index.html#hardware-used">Hardware Used</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/swarm/index.html#performance-monitoring">Performance Monitoring</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="devops/containers_orchestration/kubernetes_workflow_not_ready/index.html">Kubernetes Workflow (not ready)</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="devops/containers_orchestration/swarm_single_node_cluster/index.html">Swarm single node cluster</a><ul>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/swarm_single_node_cluster/index.html#introduction">introduction</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/containers_orchestration/swarm_single_node_cluster/index.html#services">Services:</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="devops/environments/index.html">Environments</a><ul>
<li class="toctree-l3"><a class="reference internal" href="devops/environments/index.html#curl-command-for-doing-the-same">Curl command for doing the same</a><ul>
<li class="toctree-l4"><a class="reference internal" href="devops/environments/test/index.html">Test</a><ul>
<li class="toctree-l5"><a class="reference internal" href="devops/environments/test/index.html#saas-admin">SaaS Admin</a></li>
<li class="toctree-l5"><a class="reference internal" href="devops/environments/test/index.html#site-admins">Site Admins</a></li>
<li class="toctree-l5"><a class="reference internal" href="devops/environments/test/index.html#grafana">Grafana</a></li>
<li class="toctree-l5"><a class="reference internal" href="devops/environments/test/index.html#redpanda-previously-kowl">Redpanda (previously Kowl)</a><ul>
<li class="toctree-l6"><a class="reference internal" href="devops/environments/test/index.html#how-to-ssh-into-the-vm">How to SSH into the VM</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="devops/environments/master/index.html">Master</a><ul>
<li class="toctree-l5"><a class="reference internal" href="devops/environments/master/index.html#saas-admin">SaaS Admin</a></li>
<li class="toctree-l5"><a class="reference internal" href="devops/environments/master/index.html#site-admins">Site Admins</a></li>
<li class="toctree-l5"><a class="reference internal" href="devops/environments/master/index.html#grafana">Grafana</a></li>
<li class="toctree-l5"><a class="reference internal" href="devops/environments/master/index.html#redpanda-previously-kowl">Redpanda (previously Kowl)</a><ul>
<li class="toctree-l6"><a class="reference internal" href="devops/environments/master/index.html#how-to-ssh-into-the-vm">How to SSH into the VM</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="devops/environments/prod/index.html">Prod</a><ul>
<li class="toctree-l5"><a class="reference internal" href="devops/environments/prod/index.html#tools">Tools</a></li>
<li class="toctree-l5"><a class="reference internal" href="devops/environments/prod/index.html#support-slas">Support SLAs</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="devops/environments/demo_non_swarm/index.html">Demo (non-Swarm)</a><ul>
<li class="toctree-l5"><a class="reference internal" href="devops/environments/demo_non_swarm/index.html#how-to-ssh-into-the-vm">How to SSH into the VM</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="devops/environments/swarm_cluster_dev/index.html">Swarm Cluster (dev)</a><ul class="simple">
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="devops/environments/iot_gateway/index.html">IoT Gateway</a><ul>
<li class="toctree-l5"><a class="reference internal" href="devops/environments/iot_gateway/index.html#how-to-ssh-into-the-gw">How to SSH into the GW</a><ul>
<li class="toctree-l6"><a class="reference internal" href="devops/environments/iot_gateway/index.html#clear-log">Clear log</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="devops/environments/kiwi/index.html">Kiwi</a><ul>
<li class="toctree-l5"><a class="reference internal" href="devops/environments/kiwi/index.html#how-to-ssh-into-the-machine">How to SSH into the Machine</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="devops/environments/ryzen/index.html">Ryzen</a><ul>
<li class="toctree-l5"><a class="reference internal" href="devops/environments/ryzen/index.html#how-to-ssh-into-the-machine">How to SSH into the Machine</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="devops/environments/test_muffin/index.html">Test Muffin</a><ul>
<li class="toctree-l5"><a class="reference internal" href="devops/environments/test_muffin/index.html#how-to-ssh-into-the-machine">How to SSH into the Machine</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="devops/api_dev/index.html">API Dev</a><ul>
<li class="toctree-l3"><a class="reference internal" href="devops/api_dev/sphinx_documentation/index.html">Sphinx Documentation</a><ul>
<li class="toctree-l4"><a class="reference internal" href="devops/api_dev/sphinx_documentation/index.html#step-2-adding-script-name-to-index-rst-and-creating-api-name-rst-file">Step 2- Adding script name to index.rst and creating &lt;Api_name.rst&gt; file.</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/api_dev/sphinx_documentation/index.html#step-3-build-documentation-in-confluence">Step 3-Build Documentation in Confluence-</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="devops/nginx_flask/index.html">Nginx &amp; Flask</a><ul>
<li class="toctree-l3"><a class="reference internal" href="devops/nginx_flask/nginx_flask_set_up_configuration/index.html">Nginx &amp; Flask (Set up &amp; Configuration)</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="devops/nginx_flask/nginx_port_mapping/index.html">Nginx Port Mapping</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="devops/cicd_process/index.html">CICD Process</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="devops/logging/index.html">Logging</a><ul>
<li class="toctree-l3"><a class="reference internal" href="devops/logging/index.html#introduction">Introduction</a><ul>
<li class="toctree-l4"><a class="reference internal" href="devops/logging/index.html#internal-logging-of-4px-services">1. Internal Logging of 4px services.</a><ul>
<li class="toctree-l5"><a class="reference internal" href="devops/logging/index.html#python-script">Python script:</a></li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="devops/logging/index.html#edge-logging">2. Edge logging.</a></li>
<li class="toctree-l4"><a class="reference internal" href="devops/logging/index.html#sample-logs">Sample logs</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="devops/utils/index.html">Utils</a><ul>
<li class="toctree-l3"><a class="reference internal" href="devops/utils/index.html#install-ngrok-on-arm-64">Install Ngrok on ARM-64</a></li>
<li class="toctree-l3"><a class="reference internal" href="devops/utils/index.html#how-to-setup-ngrok-service-start-ngrok-on-reboot">How to Setup ngrok.service (start ngrok on reboot)</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="devops/4pxdocs/index.html">4px.docs</a><ul>
<li class="toctree-l3"><a class="reference internal" href="devops/4pxdocs/index.html#building-sphinix-docs">Building Sphinix Docs</a></li>
<li class="toctree-l3"><a class="reference internal" href="devops/4pxdocs/index.html#guidelines-for-writing-confluence-page">Guidelines for writing confluence page</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="architecture/index.html">Architecture</a><ul>
<li class="toctree-l2"><a class="reference internal" href="architecture/index.html#key-components">Key Components</a></li>
<li class="toctree-l2"><a class="reference internal" href="architecture/index.html#sub-components">Sub Components</a><ul>
<li class="toctree-l3"><a class="reference internal" href="architecture/data_model/index.html">Data Model</a><ul>
<li class="toctree-l4"><a class="reference internal" href="architecture/data_model/data_model_json/index.html">Data Model (JSON)</a><ul>
<li class="toctree-l5"><a class="reference internal" href="architecture/data_model/data_model_json/index.html#system-indices">System Indices</a></li>
<li class="toctree-l5"><a class="reference internal" href="architecture/data_model/data_model_json/index.html#data-indices">Data Indices</a></li>
<li class="toctree-l5"><a class="reference internal" href="architecture/data_model/data_model_json/index.html#apps">Apps</a><ul>
<li class="toctree-l6"><a class="reference internal" href="architecture/data_model/data_model_json/index.html#anomaly">Anomaly</a></li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="architecture/data_model/data_model_json/index.html#user-management">User Management</a><ul>
<li class="toctree-l6"><a class="reference internal" href="architecture/data_model/data_model_json/index.html#opendistro-security">.opendistro_security</a></li>
<li class="toctree-l6"><a class="reference internal" href="architecture/data_model/data_model_json/index.html#kibana">.kibana*</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="architecture/data_model/sample_test_data/index.html">Sample Test Data</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="architecture/security/index.html">Security</a><ul>
<li class="toctree-l4"><a class="reference internal" href="architecture/security/identify_providers_ldap_jwt/index.html">Identify Providers (LDAP, JWT)</a><ul class="simple">
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="architecture/security/stack_security_tls_and_https/index.html">Stack Security (TLS and HTTPS)</a><ul class="simple">
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="architecture/security/how_to_get_authorization_token/index.html">How to get authorization token</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="architecture/other_arch_related_topics/index.html">Other Arch Related Topics</a><ul>
<li class="toctree-l4"><a class="reference internal" href="architecture/other_arch_related_topics/difference_bw_osd_1x_and_2x/index.html">Difference b/w OSD 1.x and 2.x</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="configuration_design/index.html">Configuration design</a><ul>
<li class="toctree-l2"><a class="reference internal" href="configuration_design/data_pipelines_design/index.html">Data Pipelines design</a><ul>
<li class="toctree-l3"><a class="reference internal" href="configuration_design/data_pipelines_design/index.html#data-source-types">Data Source Types</a><ul>
<li class="toctree-l4"><a class="reference internal" href="configuration_design/data_pipelines_design/index.html#edge-server">Edge Server</a><ul>
<li class="toctree-l5"><a class="reference internal" href="configuration_design/data_pipelines_design/index.html#process-data">Process data</a></li>
<li class="toctree-l5"><a class="reference internal" href="configuration_design/data_pipelines_design/index.html#iu-cloud">IU Cloud</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="configuration_design/integrations/index.html">Integrations</a><ul>
<li class="toctree-l3"><a class="reference internal" href="configuration_design/integrations/iu/index.html">IU</a><ul>
<li class="toctree-l4"><a class="reference internal" href="configuration_design/integrations/iu/iu_api_integration/index.html">IU API Integration</a><ul>
<li class="toctree-l5"><a class="reference internal" href="configuration_design/integrations/iu/iu_api_integration/index.html#iu-cloud-access-details">IU Cloud Access Details</a></li>
<li class="toctree-l5"><a class="reference internal" href="configuration_design/integrations/iu/iu_api_integration/index.html#post-login-4">1.1 POST /login 4</a></li>
<li class="toctree-l5"><a class="reference internal" href="configuration_design/integrations/iu/iu_api_integration/index.html#post-admin-getmonitorsbyplantid-5">2.1 POST /admin/getMonitorsByPlantId 5</a></li>
<li class="toctree-l5"><a class="reference internal" href="configuration_design/integrations/iu/iu_api_integration/index.html#get-md-trend-history">3.1 GET /md/trend-history</a></li>
<li class="toctree-l5"><a class="reference internal" href="configuration_design/integrations/iu/iu_api_integration/index.html#get-md-equipment-history">3.2 GET /md/equipment-history</a></li>
<li class="toctree-l5"><a class="reference internal" href="configuration_design/integrations/iu/iu_api_integration/index.html#get-md-fft-data-time">3.4 GET /md/fft-data-time</a></li>
<li class="toctree-l5"><a class="reference internal" href="configuration_design/integrations/iu/iu_api_integration/index.html#get-md-fft-data">3.5 GET /md/fft-data</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="configuration_design/integrations/iu/iu_rs_485_integration/index.html">IU RS-485 Integration</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="configuration_design/integrations/gcs/index.html">GCS</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="configuration_design/integrations/cimcon/index.html">CimCon</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="configuration_design/kafka_design/index.html">Kafka design</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="configuration_design/ssl_certificate/index.html">SSL Certificate</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="alerting_design/index.html">Alerting Design</a><ul>
<li class="toctree-l2"><a class="reference internal" href="alerting_design/ui_design/index.html">UI Design</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="alerting_design/apis_design/index.html">APIs Design</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="cm_design/index.html">CM design</a><ul>
<li class="toctree-l2"><a class="reference internal" href="cm_design/index.html#retention-properties">Retention properties</a><ul>
<li class="toctree-l3"><a class="reference internal" href="cm_design/index.html#the-following-configurations-control-the-disposal-of-log-segments-the-policy-can-be-set-to-delete-segments-after-some-time-or-after-a-given-size-has-accumulated-a-segment-will-be-deleted-whenever-either-of-these-criteria-is-met-deletion-always-happens-from-the-end-of-the-log-the-minimum-age-of-a-log-file-to-be-eligible-for-deletion-due-to-age">The following configurations control the disposal of log segments. The policy can be set to delete segments after some time, or after a given size has accumulated. A segment will be deleted whenever either of these criteria is met. Deletion always happens from the end of the log. The minimum age of a log file to be eligible for deletion due to age</a><ul>
<li class="toctree-l4"><a class="reference internal" href="cm_design/index.html#log-retention-hours-168">log.retention.hours=168</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="cm_design/index.html#a-size-based-retention-policy-for-logs-segments-are-pruned-from-the-log-unless-the-remaining-segments-drop-below-log-retention-bytes-functions-independently-of-log-retention-hours">A size-based retention policy for logs. Segments are pruned from the log unless the remaining segments drop below log.retention.bytes. Functions independently of log.retention.hours.</a><ul>
<li class="toctree-l4"><a class="reference internal" href="cm_design/index.html#log-retention-bytes-1073741824">log.retention.bytes=1073741824</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="cm_design/index.html#the-maximum-size-of-a-log-segment-file-when-this-size-is-reached-a-new-log-segment-will-be-created">The maximum size of a log segment file. When this size is reached a new log segment will be created.</a><ul>
<li class="toctree-l4"><a class="reference internal" href="cm_design/index.html#log-segment-bytes-1073741824">log.segment.bytes=1073741824</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="cm_design/index.html#the-interval-at-which-log-segments-are-checked-to-see-if-they-can-be-deleted-according-to-the-retention-policies">The interval at which log segments are checked to see if they can be deleted according to the retention policies</a><ul>
<li class="toctree-l4"><a class="reference internal" href="cm_design/index.html#log-retention-check-interval-ms-300000">log.retention.check.interval.ms=300000</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="cm_design/index.html#thread-properties">thread properties</a></li>
<li class="toctree-l2"><a class="reference internal" href="cm_design/index.html#rebalance-properties">Rebalance properties</a></li>
<li class="toctree-l2"><a class="reference internal" href="cm_design/index.html#log-properties">Log properties</a></li>
<li class="toctree-l2"><a class="reference internal" href="cm_design/index.html#consumer-properties">Consumer properties</a></li>
<li class="toctree-l2"><a class="reference internal" href="cm_design/index.html#id1">Rebalance properties</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="pdm_design/index.html">PdM Design</a><ul>
<li class="toctree-l2"><a class="reference internal" href="pdm_design/index.html#inputs">Inputs</a></li>
<li class="toctree-l2"><a class="reference internal" href="pdm_design/index.html#build-workflow">Build Workflow</a></li>
<li class="toctree-l2"><a class="reference internal" href="pdm_design/index.html#score-workflow">Score Workflow</a></li>
<li class="toctree-l2"><a class="reference internal" href="pdm_design/index.html#indices-used">Indices Used</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="ems_design/index.html">EMS Design</a><ul>
<li class="toctree-l2"><a class="reference internal" href="ems_design/index.html#computation-logic">Computation Logic</a></li>
<li class="toctree-l2"><a class="reference internal" href="ems_design/index.html#flagging-logic">Flagging Logic</a><ul>
<li class="toctree-l3"><a class="reference internal" href="ems_design/index.html#details">Details</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="ems_design/index.html#known-gaps">Known Gaps</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="notebooks_design/index.html">Notebooks design</a><ul>
<li class="toctree-l2"><a class="reference internal" href="notebooks_design/index.html#jupyterhub">Jupyterhub</a><ul>
<li class="toctree-l3"><a class="reference internal" href="notebooks_design/index.html#embedded-jupyterhub">Embedded Jupyterhub</a></li>
<li class="toctree-l3"><a class="reference internal" href="notebooks_design/index.html#installation">Installation</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="notebooks_design/index.html#jupyterhub-docker">Jupyterhub Docker</a></li>
<li class="toctree-l2"><a class="reference internal" href="notebooks_design/index.html#ml-automation-framework">ML Automation Framework</a></li>
<li class="toctree-l2"><a class="reference internal" href="notebooks_design/index.html#front-end-ui">Front-end UI</a><ul>
<li class="toctree-l3"><a class="reference internal" href="notebooks_design/index.html#dsw-scheduler-get-metrics-py">dsw_scheduler_get_metrics.py</a></li>
<li class="toctree-l3"><a class="reference internal" href="notebooks_design/index.html#dsw-scheduler-get-schedule-py">dsw_scheduler_get_schedule.py</a></li>
<li class="toctree-l3"><a class="reference internal" href="notebooks_design/index.html#dsw-scheduler-get-table-py">dsw_scheduler_get_table.py</a></li>
<li class="toctree-l3"><a class="reference internal" href="notebooks_design/index.html#dsw-scheduler-set-schedule-py">dsw_scheduler_set_schedule.py</a></li>
<li class="toctree-l3"><a class="reference internal" href="notebooks_design/index.html#dsw-scheduler-set-stopschedule-py">dsw_scheduler_set_stopschedule.py</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="notebooks_design/index.html#id1">Jupyterhub</a></li>
<li class="toctree-l2"><a class="reference internal" href="notebooks_design/index.html#id2">ML Automation Framework</a><ul>
<li class="toctree-l3"><a class="reference internal" href="notebooks_design/adding_csp_rules_to_kibana/index.html">Adding CSP Rules to Kibana</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="scheduler_design/index.html">Scheduler design</a><ul>
<li class="toctree-l2"><a class="reference internal" href="scheduler_design/index.html#python-scheduler">Python Scheduler</a><ul>
<li class="toctree-l3"><a class="reference internal" href="scheduler_design/index.html#scheduler-py">scheduler.py -</a></li>
<li class="toctree-l3"><a class="reference internal" href="scheduler_design/index.html#keep-alive-py">Keep_alive.py</a></li>
<li class="toctree-l3"><a class="reference internal" href="scheduler_design/index.html#create-system-schedule-py">create_system_schedule.py</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="consumer_design/index.html">Consumer design</a><ul>
<li class="toctree-l2"><a class="reference internal" href="consumer_design/updating_whatsapp_token/index.html">Updating WhatsApp Token</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="other_design_documentation/index.html">Other Design Documentation</a><ul>
<li class="toctree-l2"><a class="reference internal" href="other_design_documentation/email_template_for_watcher_alerts/index.html">Email template for Watcher Alerts</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="other_design_documentation/dynamic_mapper_script_for_automatic_datatype_detection/index.html">Dynamic Mapper Script for automatic datatype detection</a><ul>
<li class="toctree-l3"><a class="reference internal" href="other_design_documentation/dynamic_mapper_script_for_automatic_datatype_detection/index.html#what-is-it">What is it?</a></li>
<li class="toctree-l3"><a class="reference internal" href="other_design_documentation/dynamic_mapper_script_for_automatic_datatype_detection/index.html#how-to-use-it">How to use it?</a><ul>
<li class="toctree-l4"><a class="reference internal" href="other_design_documentation/dynamic_mapper_script_for_automatic_datatype_detection/index.html#download">Download</a></li>
<li class="toctree-l4"><a class="reference internal" href="other_design_documentation/dynamic_mapper_script_for_automatic_datatype_detection/index.html#deploy">Deploy</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="other_design_documentation/dynamic_mapper_script_for_automatic_datatype_detection/index.html#how-to-add-an-explicit-mapping-for-a-field">How to add an explicit mapping for a field?</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="other_design_documentation/unit_test_cases/index.html">Unit-Test Cases</a><ul>
<li class="toctree-l3"><a class="reference internal" href="other_design_documentation/unit_test_cases/index.html#pipelines-tab">1. Pipelines Tab</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="other_design_documentation/nozomi_integration_design/index.html">Nozomi Integration Design</a><ul>
<li class="toctree-l3"><a class="reference internal" href="other_design_documentation/nozomi_integration_design/index.html#data-extraction-and-mapping">Data Extraction and Mapping</a></li>
<li class="toctree-l3"><a class="reference internal" href="other_design_documentation/nozomi_integration_design/index.html#ingestion-processes">Ingestion Processes</a></li>
<li class="toctree-l3"><a class="reference internal" href="other_design_documentation/nozomi_integration_design/index.html#identified-gaps-in-mapping-sg-data-to-ecs">Identified Gaps in Mapping SG Data to ECS</a></li>
<li class="toctree-l3"><a class="reference internal" href="other_design_documentation/nozomi_integration_design/index.html#dashboards-created">Dashboards Created</a></li>
<li class="toctree-l3"><a class="reference internal" href="other_design_documentation/nozomi_integration_design/index.html#through-postman">Through Postman</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="other_design_documentation/monitoring_tools/index.html">Monitoring Tools</a><ul>
<li class="toctree-l3"><a class="reference internal" href="other_design_documentation/monitoring_tools/index.html#grafana">Grafana</a></li>
<li class="toctree-l3"><a class="reference internal" href="other_design_documentation/monitoring_tools/index.html#redpanda-previously-kowl">Redpanda (previously Kowl)</a><ul>
<li class="toctree-l4"><a class="reference internal" href="other_design_documentation/monitoring_tools/observability_types/index.html">Observability Types</a><ul>
<li class="toctree-l5"><a class="reference internal" href="other_design_documentation/monitoring_tools/observability_types/index.html#infra-vm-observability">1. Infra (VM) Observability:</a><ul>
<li class="toctree-l6"><a class="reference internal" href="other_design_documentation/monitoring_tools/observability_types/index.html#parameters-to-monitor-at-infra-level-vm-both-alerts-dashboards">Parameters to Monitor at INFRA Level (VM): (Both Alerts &amp; Dashboards)</a><ul>
<li class="toctree-l7"><a class="reference internal" href="other_design_documentation/monitoring_tools/observability_types/index.html#alerts-thresholds-for-last-15-mins">Alerts Thresholds for Last 15 mins:</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="other_design_documentation/monitoring_tools/observability_types/index.html#k8s-cluster-observability-management">2. K8S Cluster Observability &amp; Management:</a></li>
<li class="toctree-l5"><a class="reference internal" href="other_design_documentation/monitoring_tools/observability_types/index.html#application-level-observability">3. Application Level Observability:</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="best_practices/index.html">Best Practices</a><ul>
<li class="toctree-l2"><a class="reference internal" href="best_practices/api_code_guidelines/index.html">API code guidelines</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="best_practices/code_header/index.html">Code header</a><ul>
<li class="toctree-l3"><a class="reference internal" href="best_practices/code_header/index.html#example">Example:</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="best_practices/naming_conventions/index.html">Naming conventions</a><ul>
<li class="toctree-l3"><a class="reference internal" href="best_practices/naming_conventions/index.html#examples">Examples</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="best_practices/devcontainers_using_vscode/index.html">DevContainers using VScode</a><ul>
<li class="toctree-l3"><a class="reference internal" href="best_practices/devcontainers_using_vscode/index.html#using-devcontainers-can-help-you-keep-your-development-environment-separate-from-your-system-and-other-apps-dependecies">Using devcontainers can help you keep your development environment separate from your system and other app’s dependecies.</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="best_practices/query_dsl_learnings/index.html">Query DSL Learnings</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="front_end_dev/index.html">Front-end Dev</a><ul>
<li class="toctree-l2"><a class="reference internal" href="front_end_dev/repository_knowledge/index.html">Repository Knowledge</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="front_end_dev/4px_deployment/index.html">4PX Deployment</a><ul>
<li class="toctree-l3"><a class="reference internal" href="front_end_dev/4px_deployment/index.html#we-have-2-repositories">We have 2 Repositories:</a></li>
<li class="toctree-l3"><a class="reference internal" href="front_end_dev/4px_deployment/index.html#the-customizations-comprise-of">The Customizations comprise of:</a></li>
<li class="toctree-l3"><a class="reference internal" href="front_end_dev/4px_deployment/index.html#deployment">Deployment:</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="front_end_dev/4px_plugins/index.html">4PX Plugins</a><ul>
<li class="toctree-l3"><a class="reference internal" href="front_end_dev/4px_plugins/index.html#ui-code-structure">UI code structure</a></li>
<li class="toctree-l3"><a class="reference internal" href="front_end_dev/4px_plugins/index.html#structure-for-tabs">Structure for Tabs</a></li>
<li class="toctree-l3"><a class="reference internal" href="front_end_dev/4px_plugins/index.html#api-hooks">API Hooks</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="front_end_dev/obsolete_docs/index.html">Obsolete Docs</a><ul>
<li class="toctree-l3"><a class="reference internal" href="front_end_dev/obsolete_docs/kibana_code_integration/index.html">Kibana Code Integration</a><ul>
<li class="toctree-l4"><a class="reference internal" href="front_end_dev/obsolete_docs/kibana_code_integration/index.html#integrate-local-code-to-kibana-dev-environment">Integrate local code to Kibana dev environment.</a></li>
<li class="toctree-l4"><a class="reference internal" href="front_end_dev/obsolete_docs/kibana_code_integration/index.html#requirements">Requirements</a></li>
<li class="toctree-l4"><a class="reference internal" href="front_end_dev/obsolete_docs/kibana_code_integration/index.html#to-integrate-local-code-to-kibana-dev-environment-using-linux">To Integrate local code to Kibana dev environment using Linux.</a><ul>
<li class="toctree-l5"><a class="reference internal" href="front_end_dev/obsolete_docs/kibana_code_integration/index.html#locate-the-private-key-and-set-the-permissions">Locate the private key and set the permissions</a></li>
<li class="toctree-l5"><a class="reference internal" href="front_end_dev/obsolete_docs/kibana_code_integration/index.html#connect-to-environment-using-ssh">Connect to Environment using SSH</a></li>
<li class="toctree-l5"><a class="reference internal" href="front_end_dev/obsolete_docs/kibana_code_integration/index.html#connect-to-environment-using-sftp-client-for-file-transferring-filezilla-preferable">Connect to Environment using SFTP Client for File transferring (Filezilla Preferable).</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="front_end_dev/obsolete_docs/osd_docker_building/index.html">OSD Docker Building</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="front_end_dev/obsolete_docs/plugin_structure/index.html">Plugin Structure</a><ul>
<li class="toctree-l4"><a class="reference internal" href="front_end_dev/obsolete_docs/plugin_structure/index.html#the-plugininitializer">The PluginInitializer</a></li>
<li class="toctree-l4"><a class="reference internal" href="front_end_dev/obsolete_docs/plugin_structure/index.html#the-plugin-class">The Plugin class</a></li>
<li class="toctree-l4"><a class="reference internal" href="front_end_dev/obsolete_docs/plugin_structure/index.html#applications">Applications</a><ul>
<li class="toctree-l5"><a class="reference internal" href="front_end_dev/obsolete_docs/plugin_structure/index.html#opensearch-dashboards-plugin-generator">OpenSearch Dashboards Plugin Generator</a><ul>
<li class="toctree-l6"><a class="reference internal" href="front_end_dev/obsolete_docs/plugin_structure/index.html#setup">Setup</a></li>
<li class="toctree-l6"><a class="reference internal" href="front_end_dev/obsolete_docs/plugin_structure/index.html#create-new-plugin">Create new plugin</a></li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="front_end_dev/obsolete_docs/plugin_structure/index.html#plugin-development-scripts">Plugin Development Scripts</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="front_end_dev/obsolete_docs/osd_developement_environment_setup/index.html">OSD Developement Environment Setup</a><ul>
<li class="toctree-l4"><a class="reference internal" href="front_end_dev/obsolete_docs/osd_developement_environment_setup/index.html#prerequisites">Prerequisites</a><ul>
<li class="toctree-l5"><a class="reference internal" href="front_end_dev/obsolete_docs/osd_developement_environment_setup/index.html#bootstrap-opensearch-dashboards">Bootstrap OpenSearch Dashboards</a></li>
<li class="toctree-l5"><a class="reference internal" href="front_end_dev/obsolete_docs/osd_developement_environment_setup/index.html#configure-opensearch-dashboards">Configure OpenSearch Dashboards</a></li>
<li class="toctree-l5"><a class="reference internal" href="front_end_dev/obsolete_docs/osd_developement_environment_setup/index.html#run-opensearch">Run OpenSearch</a></li>
<li class="toctree-l5"><a class="reference internal" href="front_end_dev/obsolete_docs/osd_developement_environment_setup/index.html#run-opensearch-dashboards">Run OpenSearch Dashboards</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="front_end_dev/obsolete_docs/4px_plugin_structure/index.html">4px Plugin Structure</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="edge_design/index.html">Edge Design</a><ul>
<li class="toctree-l2"><a class="reference internal" href="edge_design/index.html#folder-structure">Folder Structure</a></li>
<li class="toctree-l2"><a class="reference internal" href="edge_design/index.html#scripts">Scripts</a></li>
<li class="toctree-l2"><a class="reference internal" href="edge_design/index.html#cron-schedule">Cron Schedule</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</div>
</section>


           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2024, 4PointX.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>